%define contentdir /var/lib/rrdcached

%{!?perl_vendorarch: %define perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)}
%{!?perl_vendorlib: %define perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c 'from distutils.sysconfig import get_python_lib; import sys; sys.stdout.write(get_python_lib(1))')}
%{!?python_version: %define python_version %(%{__python} -c 'import sys; sys.stdout.write(sys.version[:3])')}
%{!?ruby_sitearch: %define ruby_sitearch %(ruby -rrbconfig -e "puts RbConfig::CONFIG['sitearchdir']" 2>/dev/null)}
%{!?ruby_archdir: %define ruby_archdir %(ruby -rrbconfig -e "puts RbConfig::CONFIG['archdir']" 2>/dev/null)}

Summary: Round Robin Database Tool to store and display time-series data
Name: rrdtool
Version: 1.5.5
Release: 0.4%{?dist}
License: GPL
Group: Applications/Databases
URL: http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/

Packager: William R. Lorenz <wrl@express.org>
Vendor: http://packages.express.org/

Source0: http://oss.oetiker.ch/rrdtool/pub/rrdtool-%{version}.tar.gz
Source1: rrdcached.init
Source2: rrdcached.sysconf
Source3: pcre-8.38.tar.bz2

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: freetype-devel, gcc-c++, libpng-devel, libxml2-devel, openssl-devel
BuildRequires: python-devel >= 2.4, ruby-devel, tcl-devel, tk-devel, ruby
BuildRequires: zlib-devel, gettext-devel, perl(ExtUtils::MakeMaker), /usr/bin/h2xs
BuildRequires: intltool >= 0.35.0, make, groff

Requires: libxml2, openssl, python, ruby, zlib, gettext
Requires: perl
Requires: initscripts >= 8.36

Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv
Prereq: sh-utils, textutils, /usr/sbin/useradd

%if 0%{?el4}
BuildRequires: evolution28-pango-devel
BuildRequires: evolution28-cairo-devel
BuildRequires: evolution28-glib2-devel
Requires: evolution28-pango
Requires: evolution28-cairo
Requires: evolution28-glib2
%else
BuildRequires: pango-devel
BuildRequires: cairo-devel
BuildRequires: glib2-devel
BuildRequires: xulrunner-devel
Requires: pango
Requires: cairo
Requires: glib2
%endif

%if 0%{?el5}
BuildRequires: dejavu-lgc-fonts
Requires: dejavu-lgc-fonts
%else
BuildRequires: dejavu-lgc-sans-fonts
BuildRequires: dejavu-lgc-sans-mono-fonts
BuildRequires: dejavu-sans-fonts
BuildRequires: dejavu-sans-mono-fonts
Requires: dejavu-lgc-sans-fonts
Requires: dejavu-lgc-sans-mono-fonts
Requires: dejavu-sans-fonts
Requires: dejavu-sans-mono-fonts
%endif

%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). It stores the data in a very compact way that will not
expand over time, and it presents useful graphs by processing the data to
enforce a certain data density. It can be used either via simple wrapper
scripts (from shell or Perl) or via frontends that poll network devices and
put a friendly user interface on it.

%package devel
Summary: RRDtool static libraries and header files
Group: Development/Libraries
Requires: %{name} = %{version}

%description devel
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). This package allow you to use directly this library.

%package -n rrdtool-perl
Summary: Perl RRDtool bindings
Group: Development/Languages
Requires: %{name} = %{version}
Obsoletes: rrdtool-perl <= %{version}-%{release}
Provides: rrdtool-perl = %{version}-%{release}

%description -n rrdtool-perl
The Perl RRDtool bindings

%package -n rrdtool-tcl
Summary: TCL bindings
Group: Development/Languages
Requires: %{name} = %{version}
Obsoletes: rrdtool-tcl <= %{version}-%{release}
Provides: rrdtool-tcl = %{version}-%{release}

%description -n rrdtool-tcl
The TCL RRDtool bindings

%package -n rrdtool-python
Summary: Python RRDtool bindings
Group: Development/Languages
BuildRequires: python
Requires: python >= 2.4
Requires: %{name} = %{version}
Obsoletes: rrdtool-python <= %{version}-%{release}
Provides: rrdtool-python = %{version}-%{release}

%description -n rrdtool-python
Python RRDtool bindings.

%package -n rrdtool-ruby
Summary: RRDtool module for Ruby
Group: Development/Languages
Requires: %{name} = %{version}, ruby-devel
Obsoletes: rrdtool-ruby <= %{version}-%{release}
Provides: rrdtool-ruby = %{version}-%{release}

%description -n rrdtool-ruby
The ruby-%{name} package includes a library that implements RRDtool bindings
for the Ruby language.

%prep
echo "perl_vendorarch: %{perl_vendorarch}"
echo "perl_vendorlib: %{perl_vendorlib}"
echo "python_sitearch: %{python_sitearch}"
echo "python_version: %{python_version}"
echo "ruby_sitearch: %{ruby_sitearch}"
echo "ruby_archdir: %{ruby_archdir}"
echo "use old fonts? %{oldfonts}"

%if 0%{?el4}
# Filter auto-requires for pango
cat > find-requires-%{name} <<EOT
#!/bin/sh
%{__find_requires} | grep -v 'pango'
exit 0
EOT
chmod 755 find-requires-%{name}
%define __find_requires %{_builddir}/find-requires-%{name}
%define _use_internal_dependency_generator 0
%endif

%setup
%setup -T -a3 -D

%build
%if 0%{?el4}
export LD_LIBRARY_PATH=/usr/evolution28/%{_lib}
export PKG_CONFIG_PATH=/usr/evolution28/%{_lib}/pkgconfig
export RUBYARCHDIR=%{ruby_sitearch}
export CFLAGS="`pkg-config --cflags cairo pangocairo pango pangoft2`"
export LDFLAGS="`pkg-config --libs  cairo pangocairo pango pangoft2`"
%endif

pushd pcre-8.38
	./configure --prefix="$RPM_BUILD_DIR/pcre" \
		--disable-shared \
		--with-pic \
		--enable-utf \
		--enable-unicode-properties \
		--enable-pcre8 \
		--enable-pcre16 \
		--enable-pcre32 \
		--enable-jit
	make
	make install
popd

export CFLAGS="-I$RPM_BUILD_DIR/pcre/include $CFLAGS"
export LDFLAGS="-L$RPM_BUILD_DIR/pcre/lib $LDFLAGS"
export LIBS="$LIBS $RPM_BUILD_DIR/pcre/lib/libpcre.a"
export LD_LIBRARY_PATH="$RPM_BUILD_DIR/pcre/lib:$LD_LIBRARY_PATH"
export PKG_CONFIG_PATH="$RPM_BUILD_DIR/pcre/lib/pkgconfig:$PKG_CONFIG_PATH"

%configure \
    --with-pic \
    --with-tcllib="%{_libdir}" \
    --with-perl-options='INSTALLDIRS="vendor"' \
    --enable-ruby-site-install \
    --disable-silent-rules

%if 0%{?el4}
%{__make} %{?_smp_mflags}  LDFLAGS="-Wl,-rpath-link /usr/evolution28/%{_lib} -Wl,-rpath /usr/evolution28/%{_lib} $LDFLAGS"
%else
#%{__make} %{?_smp_mflags}
%{__make} -j1 LIBTOOL='$(SHELL) $(top_builddir)/libtool --verbose' LIBS="$LIBS"
%endif

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR="%{buildroot}"

find %{buildroot} -name .packlist -exec %{__rm} {} \;
%{__rm} -f %{buildroot}%{perl_archlib}/perllocal.pod
%{__rm} -f %{buildroot}%{perl_vendorarch}/ntmake.pl

# put rrdcached in its proper place
%{__mkdir} -p %{buildroot}%{_sbindir}
%{__mv} -f %{buildroot}%{_bindir}/rrdcached %{buildroot}%{_sbindir}/rrdcached

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/rrdcached.init \
        $RPM_BUILD_ROOT/etc/rc.d/init.d/rrdcached
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
        $RPM_BUILD_ROOT/etc/rc.d/init.d/rrdcached

# install conf file/directory
mkdir $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 644 $RPM_SOURCE_DIR/rrdcached.sysconf \
   $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/rrdcached

# make the proper /var directories
mkdir -p $RPM_BUILD_ROOT/var/run/rrdcached
mkdir -p $RPM_BUILD_ROOT/var/lib/rrdcached

if [ -d "$RPM_BUILD_ROOT/usr/lib/systemd" ]; then
	rm -rf "$RPM_BUILD_ROOT/usr/lib/systemd"
fi

extra_docs="$RPM_BUILD_ROOT/$RPM_DOC_DIR/%{name}-%{version}"
if [ -d "$extra_docs/txt" ]; then
	rm -rf "$extra_docs/txt"
fi
if [ -d "$extra_docs/html" ]; then
	rm -rf "$extra_docs/html"
fi

pushd "$RPM_BUILD_ROOT%{python_sitearch}"
	find * -type f | sort -u | sed -e 's,^,%{python_sitearch}/,' > %{_tmppath}/files.egg
popd

echo "=== egg ==="
cat %{_tmppath}/files.egg

%pre
# Add the "rrdcache" user
/usr/sbin/useradd -c "rrdcached" -u 98 \
        -s /sbin/nologin -r -d %{contentdir} rrdcache 2> /dev/null || :


%post
# Register the rrdcached service
/sbin/chkconfig --add rrdcached
/sbin/chkconfig rrdcached off


%preun
if [ $1 = 0 ]; then
        /sbin/service rrdcached stop > /dev/null 2>&1
        /sbin/chkconfig --del rrdcached
fi


%clean
%{__rm} -rf %{buildroot}
%if 0%{?el4}
%{__rm} -f %{_builddir}/find-requires-%{name}
%endif


%files
%defattr(-, root, root, 0755)
%doc CHANGES CONTRIBUTORS COPYRIGHT LICENSE NEWS THREADS TODO
%doc examples/ 
%doc %{_mandir}/man1/*.1*
%doc %{_mandir}/man3/*.3*
%{_bindir}/rrdcgi
%{_bindir}/rrdcreate
%{_bindir}/rrdinfo
%{_bindir}/rrdtool
%{_bindir}/rrdupdate
%{_sbindir}/rrdcached
%{_libdir}/librrd.so.*
%{_libdir}/librrd_th.so.*
%{_libdir}/librrd.a
%{_libdir}/librrd_th.a
%{_libdir}/pkgconfig/librrd.pc
%{_datadir}/rrdtool/
%{_includedir}/rrd_format.h

%config(noreplace) %{_sysconfdir}/sysconfig/rrdcached
%config %{_sysconfdir}/rc.d/init.d/rrdcached

%dir %{contentdir}

%attr(0755,rrdcache,rrdcache) %dir /var/run/rrdcached
%attr(0755,rrdcache,rrdcache) %dir %{contentdir}


%files devel
%defattr(-, root, root, 0755)
%{_includedir}/rrd.h
%{_includedir}/rrd_client.h
%{_libdir}/librrd.so
%{_libdir}/librrd_th.so
%exclude %{_libdir}/librrd.la
%exclude %{_libdir}/librrd_th.la

%files -n rrdtool-perl
%defattr(-, root, root, 0755)
%doc bindings/perl-shared/MANIFEST bindings/perl-shared/README
%doc %{_mandir}/man3/RRDp.3*
%doc %{_mandir}/man3/RRDs.3*
%{perl_vendorarch}/RRDs.pm
%{perl_vendorarch}/auto/RRDs/*
%{perl_vendorlib}/RRDp.pm

%files -n rrdtool-tcl
%defattr(-, root, root, 0755)
%doc bindings/tcl/README
%{_libdir}/rrdtool/ifOctets.tcl
%{_libdir}/rrdtool/pkgIndex.tcl
%{_libdir}/tclrrd%{version}.so

%files -n rrdtool-python -f %{_tmppath}/files.egg
%defattr(-, root, root, 0755)
%doc bindings/python/ACKNOWLEDGEMENT bindings/python/AUTHORS bindings/python/COPYING bindings/python/README

%files -n rrdtool-ruby
%defattr(-, root, root, 0755)
%doc bindings/ruby/CHANGES bindings/ruby/README
%{ruby_sitearch}/RRD.so

%changelog
* Tue Jun 30 2015 Benjamin Reed <ranger@opennms.org> - 1.5.3-01.wrl
- Hacked to 1.5.3

* Sun Mar 10 2013 William R. Lorenz <wrl@express.org> - 1.4.7-1.wrl
- Update to 1.4.7

* Sun Mar 10 2013 William R. Lorenz <wrl@express.org> - 1.4.6-1.wrl
- Update to 1.4.6

* Sun Sep 25 2011 William R. Lorenz <wrl@express.org> - 1.4.5-1.wrl
- Update to 1.4.5

* Sun Aug  1 2010 William R. Lorenz <wrl@express.org> - 1.4.4-1.wrl
- Update to 1.4.4

* Sun Aug  1 2010 William R. Lorenz <wrl@express.org> - 1.4.3-1.wrl
- Update to 1.4.3

* Sun Aug  1 2010 William R. Lorenz <wrl@express.org> - 1.4.2-1.wrl
- Update to 1.4.2

* Wed Oct 28 2009 William R. Lorenz <wrl@express.org> - 1.4.1-1.wrl
- Update to 1.4.1

* Wed Oct 28 2009 William R. Lorenz <wrl@express.org> - 1.3.9-1.wrl
- Update to 1.3.9

* Sat Jul 18 2009 William R. Lorenz <wrl@express.org> - 1.3.8-1.wrl
- Update to 1.3.8

* Fri May 15 2009 Christoph Maser <cmr@financial.com> - 1.3.7-1 - 6801/cmr
- Update to 1.3.7

* Fri Feb 13 2009 Christoph Maser <cmr@financial.com> - 1.3.6-1
- Update to 1.3.6

* Mon Jan 05 2009 Christoph Maser <cmr@financial.com> - 1.3.5-2
- Remove fc10 conditionals
- Compile against evolution28 version of pango,cairo,glib on el4

* Tue Dec 30 2008 Christoph Maser <cmr@financial.com> - 1.3.5-1
- Update version
- Add BuildRequires: ruby for macro expansion
- Add BuildRequires: gettext-devel
- Add Requires: gettext
- Add fc10 conditionals

* Sun Nov 23 2008 Christoph Maser <cmr@financial.com> - 1.3.4-2
- Removed 1.2.x patches.
- Removed dependencies cgilib.
- Added dependencies pango, cairo.

* Sun Nov 23 2008 Christoph Maser <cmr@financial.com> - 1.3.4-1
- Updated to release 1.3.4.

* Wed Oct 15 2008 Christoph Maser <cmr@financial.com> - 1.2.28-1
- Updated to release 1.2.28.

* Wed Jun 06 2007 Dag Wieers <dag@wieers.com> - 1.2.23-1
- Updated to release 1.2.23.

* Wed May 02 2007 Dag Wieers <dag@wieers.com> - 1.2.21-1
- Updated to release 1.2.21.

* Fri Jan 26 2007 Dag Wieers <dag@wieers.com> - 1.2.18-1
- Updated to release 1.2.18.

* Wed Jul 19 2006 Dag Wieers <dag@wieers.com> - 1.2.15-1
- Updated to release 1.2.15.

* Fri May 05 2006 Dag Wieers <dag@wieers.com> - 1.2.13-1
- Updated to release 1.2.13.

* Mon Dec 19 2005 Dag Wieers <dag@wieers.com> - 1.2.12-1
- Updated to release 1.2.12.

* Wed Jul 27 2005 Dag Wieers <dag@wieers.com> - 1.2.11-1
- Updated to release 1.2.11.
- Fixes for x86_64 and perl/tcl/python bindings.

* Sat Jun 04 2005 Dag Wieers <dag@wieers.com> - 1.2.9-1
- Updated to release 1.2.9.

* Wed May 18 2005 Dag Wieers <dag@wieers.com> - 1.2.8-1
- Updated to release 1.2.8.

* Tue May 10 2005 Dag Wieers <dag@wieers.com> - 1.2.6-1
- Updated to release 1.2.6.

* Sat May 07 2005 Dag Wieers <dag@wieers.com> - 1.2.2-1
- Updated to release 1.2.2.

* Sat May 07 2005 Dag Wieers <dag@wieers.com> - 1.2.1-1
- Updated to release 1.2.1.

* Fri Apr 29 2005 Dag Wieers <dag@wieers.com> - 1.2.0-1
- Updated to release 1.2.0.

* Mon Apr 04 2005 Dag Wieers <dag@wieers.com> - 1.0.49-2
- Fix for the php-rrdtool patch. (Joe Pruett)

* Thu Aug 25 2004 Dag Wieers <dag@wieers.com> - 1.0.49-1
- Updated to release 1.0.49.

* Wed Aug 25 2004 Dag Wieers <dag@wieers.com> - 1.0.48-3
- Fixes for x86_64. (Garrick Staples)

* Fri Jul  2 2004 Matthias Saou <http://freshrpms.net/> 1.0.48-3
- Actually apply the patch for fixing the php module, doh!

* Thu May 27 2004 Matthias Saou <http://freshrpms.net/> 1.0.48-2
- Added php.d config entry to load the module once installed.

* Thu May 13 2004 Dag Wieers <dag@wieers.com> - 1.0.48-1
- Updated to release 1.0.48.

* Tue Apr 06 2004 Dag Wieers <dag@wieers.com> - 1.0.47-1
- Updated to release 1.0.47.

* Thu Mar  4 2004 Matthias Saou <http://freshrpms.net/> 1.0.46-2
- Change the strict dependency on perl to fix problem with the recent
  update.

* Mon Jan  5 2004 Matthias Saou <http://freshrpms.net/> 1.0.46-1
- Update to 1.0.46.
- Use system libpng and zlib instead of bundled ones.
- Added php-rrdtool sub-package for the php4 module.

* Fri Dec  5 2003 Matthias Saou <http://freshrpms.net/> 1.0.45-4
- Added epoch to the perl dependency to work with rpm > 4.2.
- Fixed the %% escaping in the perl dep.

* Mon Nov 17 2003 Matthias Saou <http://freshrpms.net/> 1.0.45-2
- Rebuild for Fedora Core 1.

* Sun Aug  3 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.0.45.

* Wed Apr 16 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.0.42.

* Mon Mar 31 2003 Matthias Saou <http://freshrpms.net/>
- Rebuilt for Red Hat Linux 9.

* Wed Mar  5 2003 Matthias Saou <http://freshrpms.net/>
- Added explicit perl version dependency.

* Sun Feb 23 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.0.41.

* Fri Jan 31 2003 Matthias Saou <http://freshrpms.net/>
- Update to 1.0.40.
- Spec file cleanup.

* Fri Jul 05 2002 Henri Gomez <hgomez@users.sourceforge.net>
- 1.0.39

* Mon Jun 03 2002 Henri Gomez <hgomez@users.sourceforge.net>
- 1.0.38

* Fri Apr 19 2002 Henri Gomez <hgomez@users.sourceforge.net>
- 1.0.37

* Tue Mar 12 2002 Henri Gomez <hgomez@users.sourceforge.net>
- 1.0.34
- rrdtools include zlib 1.1.4 which fix vulnerabilities in 1.1.3

